#include<pic16f877a.h>
//#include<stdio.h>
//__CONFIG(FOSC_INTOSCIO & CP_OFF & BOREN_OFF & WDTE_OFF & PWRTE_OFF & LVP_OFF & MCLRE_ON);
#define _XTAL_FREQ 11000000UL 
//#include <config.h>
//#define _MSDelay 20000000

#define ldata PORTB
#define rs PORTCbits.RC0
#define en PORTCbits.RC1

//void TX(unsigned char TX_BYTE);
void Uart_init();
void  UART0_SendByte(unsigned char data);
void  UART0_SendStr(const unsigned char *str);
void Calcul_velo(unsigned int val);
void Display_Freq(unsigned int freq2write) ;
void Lcd_Cmd(unsigned char value);
void Lcd_display(unsigned char value);
void delay_lcd(unsigned int time);
void delay();


const char txt1[15]="Frequency=\n";
const char txt2[10] = "Hz\n";
const char txt3[20] = "out of range\n";
//const char txt4[30] = "Wind speed>53Kn\n ";
int i;
unsigned char freq[6] ;
 //char *freq[] = "0000";

void main()
{ 
    
//	unsigned int time;
	//PORTA = 0x10;
 	PORTAbits.RA4 = 1;
	TRISB = 0x00;
	TRISC = 0x00;
 	//Lcd_Init();
 	Lcd_Cmd(0x38);
 	delay();
 	Lcd_Cmd(0x0c);
 	delay();
 	Lcd_Cmd(0x01);
 	delay();
 	Lcd_Cmd(0x06);
 	delay();
	Lcd_Cmd(0x80);
	delay();
 	for(i=0;i<15;i++)
		Lcd_display(txt1[i]);
 	
    OPTION_REG = 0x00;	
	OPTION_REGbits.PS0=0;
    OPTION_REGbits.PS1=0;
	OPTION_REGbits.PS2=0;
	OPTION_REGbits.PSA=1;
	OPTION_REGbits.T0SE=0;
	OPTION_REGbits.T0CS=1;
	delay();
    //TMR0=0;
	while(1)
    {
    	TMR0=0;
	    INTCON = 0B00100000;
        delay();
        if(INTCONbits.TMR0IF)
		{
           	Lcd_Cmd(0x80);
			delay();
           	for(i=0;i<20;i++)
            {  
				Lcd_display(txt3[i]);
			}
			delay();
		}
		
		//Calcul_velo(TMR0);
        Display_Freq(TMR0);
	
	}
}




void Calcul_velo(unsigned int val)
{
 	int n=40,V_INT;                 //n=number of slots
 	float C,V,RPS,s;
 	RPS=(float)val/n;
 	C=6*3.14*0.23;
 	V= RPS*C*1.94;
 	V_INT = (int)V;//s=1.94*V;
    //Lcd_display(V_INT);
 	Display_Freq(V);
 	//Delay_ms(2000);
 	//UART0_SendByte(V_INT);
    
}


void Display_Freq(unsigned int freq2write) 
{ 
    freq[0] = (freq2write/1000)+48 ;
 	freq[1] = (freq2write/100)%10+48 ;
 	freq[2] = (freq2write/10)%10+48;
 	freq[3] =  freq2write%10+48 ;
  	Lcd_Cmd(0x8A);
 	
   for(i=0;i<5;i++)
 	Lcd_display(freq[i]);
   // Lcd_display(freq);
 	Lcd_Cmd(0x8E);
 	delay();
 	for(i=0;i<10;i++)
		Lcd_display(txt2[i]);        
}



void Lcd_Cmd(unsigned char value)
{
	ldata = value;
	rs = 0;
	en = 1;
	delay_lcd(30);
	en = 0;
}


void Lcd_display(unsigned char value)
{
	ldata = value;
	rs = 1;
	en = 1;
	delay_lcd(30);
	en = 0;
}


void delay_lcd(unsigned int time)
{
	unsigned int i,j;
	for(i=0;i<time;i++)
		for(j=0;j<135;j++);
}

void delay()
{ 
	unsigned i;
	for(i=0;i<10000;i++);
} 