
sbit LCD_RS at RC0_bit;

sbit LCD_EN at RC1_bit;

sbit LCD_D0 at RB0_bit;

sbit LCD_D1 at RB1_bit;

sbit LCD_D2 at RB2_bit;

sbit LCD_D3 at RB3_bit;

sbit LCD_D4 at RB4_bit;

sbit LCD_D5 at RB5_bit;

sbit LCD_D6 at RB6_bit;

sbit LCD_D7 at RB7_bit;

sbit LCD_RS_Direction at TRISC0_bit;

sbit LCD_EN_Direction at TRISC1_bit;

sbit LCD_D0_Direction at TRISB0_bit;

sbit LCD_D1_Direction at TRISB1_bit;

sbit LCD_D2_Direction at TRISB2_bit;

sbit LCD_D3_Direction at TRISB3_bit;

sbit LCD_D4_Direction at TRISB4_bit;

sbit LCD_D5_Direction at TRISB5_bit;

sbit LCD_D6_Direction at TRISB6_bit;

sbit LCD_D7_Direction at TRISB7_bit;

char txt1[] = "Frequency= ";
char txt2[] = "Hz";
char txt3[] = "Out of range";
//char txt4[] = "Wind speed>53Kn ";
char *freq = "0000";


void Display_Freq(unsigned int freq2write) {

 freq[0] = (freq2write/1000)+ 48;

 freq[1] = (freq2write/100)%10 + 48;

 freq[2] = (freq2write/10)%10 + 48;

 freq[3] =  freq2write%10     + 48;

 Lcd_Out(1,11,freq);
 //UART1_Write_text(freq);


}



void Calcul_velo(unsigned int val)
{
     int n=40,S_INT;                 //n=number of slots
     float C,V,RPM,S;
     RPM=(float)val*60/n;
     V=0.23*RPM*0.10472;           //V=r*RPM*0.10472   m/s
     S =  V*18/5;                 //m/s to km/hr
     Display_Freq(S);
     //Delay_ms(2000);
     //UART1_Write(S);
 }

void main()
 {

 TRISB = 0x00;

 TRISA = 0b00010000;
  Lcd_Init();

 Lcd_Cmd(_LCD_CLEAR);

 Lcd_Cmd(_LCD_CURSOR_OFF);

 Lcd_Out(1,1,txt1);
 //UART1_Init(9600);
  Delay_ms(100);
  //UART1_Write_text("Speed=");
 OPTION_REG = 0b00101000;
  while(1)
  {
    TMR0=0;
    INTCON = 0b00100000;
    Delay_ms(1000);
    if (INTCON.TMR0IF)
    {
     //Lcd_Out(1,1,txt3);
          Lcd_Out(1,1,txt3);
          Delay_ms(1000);
          Lcd_Cmd(_LCD_CLEAR);
    }
    Display_Freq(TMR0);
   // Calcul_velo(TMR0);
    Lcd_Out(1,15,txt2);
    //            Delay_ms(1000);
    //UART1_Write_text("kn");
    }
}